#
#  xformclone.rb v1.0
#  Interactive transform-n-clone
#
#  Created by Adam Billyard on 11/09/2008.
#  Copyright (c) 2008 Billyard Enterprises. All rights reserved.
#


class CloneTool

	def xformclone(second, delta, num)

		Sketchup.active_model.start_operation("记忆复制")
		num.times do
			second = second.parent.entities.add_instance(second.definition, delta * second.transformation)
		end
		Sketchup.active_model.commit_operation
		
		return second
	end
	
	def activate
		@first = Sketchup.active_model.selection[0]
		@second = nil
		@head = nil
		@delta = nil
		@count = 1
	end

	def setprev(atool)
		@prevtool = atool
	end

	def onUserText(text, view)
		if (text[-1] == 88) or (text[-1] == 120)
			@count = eval(text[0...-1])
		end
	end

	def onMouseMove(flags, x, y, view)
	
		unless @first
			Sketchup.active_model.select_tool(@prevtool)
		end
	
		ph = view.pick_helper
		ph.do_pick(x,y)
		thispick = ph.best_picked
		if thispick != @second
			Sketchup.active_model.selection.clear
			Sketchup.active_model.selection.add(@first)
			@second = false
			if thispick
				if thispick.kind_of?(Sketchup::ComponentInstance) and (thispick.definition == @first.definition)
					@second = thispick
					@delta = @second.transformation * (@first.transformation.inverse)
					Sketchup.active_model.selection.add(@second)
					
					@head = @second
				end
			end
		end
	end
	
	def onLButtonDown(flags, x, y, view)
	
		unless @first
			Sketchup.active_model.select_tool(@prevtool)
		end
	
		ph = view.pick_helper
		ph.do_pick(x,y)
		thispick = ph.best_picked
		if thispick and thispick == @second
			@head = xformclone(@head, @delta, @count)
		else
			Sketchup.active_model.select_tool(@prevtool)
		end
	end

end


if( not file_loaded?(__FILE__) )

	UI.add_context_menu_handler do |menu|
		menu.add_separator
		menu.add_item("记忆复制..") {
			newtool = CloneTool.new
			newtool.setprev(Sketchup.active_model.select_tool(nil))
			Sketchup.active_model.select_tool(CloneTool.new) if Sketchup.active_model.selection[0].kind_of?(Sketchup::ComponentInstance)
		}
	end 

	file_loaded(__FILE__)

        # 以下部分是添加图标的代码
    toolbar = UI::Toolbar.new "记忆复制"
    cmd = UI::Command.new("记忆复制") {
            newtool = CloneTool.new
            newtool.setprev(Sketchup.active_model.select_tool(nil))
            Sketchup.active_model.select_tool(CloneTool.new) if Sketchup.active_model.selection[0].kind_of?(Sketchup::ComponentInstance)
        }
    cmd.tooltip = "记忆复制"
    cmd.status_bar_text = '对组件的复制(旋转复制、镜像等)或缩放进行记忆复制,可以用来做旋转楼梯等等。操作方法：先复制一个组件、对其进行位置或比例的调整、然后选择第一个组件、点击记忆复制、再多次点击复制出来的那个组件。'
    cmd.small_icon = "xformclone/MemoryCopy.png"
    cmd.large_icon = "xformclone/MemoryCopy.png"
    toolbar = toolbar.add_item cmd
    toolbar.show
    puts cmd.large_icon
    # 以上部分是添加图标的代码
end